SystemOrganization addCategory: #'MC2-SqueakPlatform'!

Object subclass: #MDAuthorInfo
	instanceVariableNames: ''
	classVariableNames: 'Author LastImageName'
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:23'!
initialize
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:09'!
prompt
	^ ' Please enter you name and email address for Monticello2 '! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:23'!
shutDown
	LastImageName _ SmalltalkImage current imageName! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:23'!
startUp
	LastImageName = SmalltalkImage current imageName
		ifFalse: [Author _ nil]! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:24'!
value
	^ Author ifNil: 
		[Author _ MDPlatform current prompt: self prompt default: '']! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:24'!
value: aString
	"Set the name and email address of the user of the system."
	
	Author _ aString! !

Object subclass: #MDNotificationAdaptor
	instanceVariableNames: 'listeners'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDNotificationAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/9/2008 16:56'!
default
	^ Instance ifNil: 
		[Instance _ self new. 
		Instance register]! !

!MDNotificationAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/9/2008 16:57'!
reset
	Instance ifNotNil: [Instance unregister].
	Instance _ nil! !

!MDNotificationAdaptor methodsFor: 'listeners' stamp: 'cwp 3/9/2008 15:21'!
addListener: anObject
	listeners add: anObject! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/10/2008 20:09'!
announce: anElement toAll: objects startingAt: start
	| listener |
	(start to: objects size) do: 
		[:i | 
		[listener _ objects at: i.
		listener ifNotNil: [listener noteElementChanged: anElement]]
			on: Halt, Exception
			do: 
				[:exc | 
				self announce: anElement toAll: objects startingAt: i+1.
				exc pass]]! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 15:20'!
initialize
	listeners _ WeakSet new.
	 ! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 15:15'!
noteClassChanged: anEvent
	| element |
	element _ MDClassElement className: anEvent item name.
	self noteElementChanged: element! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 13:18'!
noteClassCommented: anEvent
	| element |
	element _ MDClassCommentElement className: (anEvent item name).
	self noteElementChanged: element! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 4/7/2008 21:54'!
noteClassModified: anEvent

	anEvent item isMeta ifFalse: [self processClass: anEvent].
	anEvent areInstVarsModified ifTrue: [self processInstVars: anEvent].
	anEvent areClassVarsModified ifTrue: [self processClassVars: anEvent].
	anEvent areSharedPoolsModified ifTrue: [self processPools: anEvent].! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 15:52'!
noteElementChanged: anElement
	self announce: anElement toAll: listeners asArray startingAt: 1! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 15:00'!
noteMethodChanged: anEvent
	| element class |
	class := anEvent environmentAt: #class.
	element := MDMethodElement
				className: class theNonMetaClass name
				selector: (anEvent environmentAt: #selector)
				classIsMeta: class isMeta.
	self noteElementChanged: element ! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 14:32'!
processClass: anEvent
	| element |
	(anEvent isSuperclassModified or: [anEvent item category ~= anEvent oldItem category])
		ifTrue:
			[element _ MDClassElement className: anEvent item name.
			self noteElementChanged: element].! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 14:38'!
processClassVars: anEvent
	| changed element |
	changed _ self xor: anEvent classVarNames with: anEvent oldClassVarNames.
	changed do:
		[:name |
		element _ MDClassVarElement className: anEvent item name name: name.
		self noteElementChanged: element]! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 15:01'!
processInstVars: anEvent
	| changed element class |
	changed _ self xor: anEvent instVarNames with: anEvent oldInstVarNames.
	changed do:
		[:name |
		class _ anEvent item isMeta ifTrue: [MDClassInstVarElement] ifFalse: [MDInstVarElement].
		element _ class className: anEvent item name name: name.
		self noteElementChanged: element]! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 14:49'!
processPools: anEvent
	| changed element name |
	changed _ self xor: anEvent sharedPools with: anEvent oldSharedPools.
	changed do:
		[:pool |
		name _ Smalltalk keyAtValue: pool.
		element _ MDPoolImportElement className: anEvent item name name: name.
		self noteElementChanged: element]! !

!MDNotificationAdaptor methodsFor: 'registration' stamp: 'cwp 3/9/2008 15:14'!
register
	SystemChangeNotifier uniqueInstance 
		notify: self 
		ofSystemChangesOfItem: #class 
		change: #Commented 
		using: #noteClassCommented:;
		
		notify: self 
		ofSystemChangesOfItem: #class 
		change: #Modified 
		using: #noteClassModified:;
		
		notify: self
		ofSystemChangesOfItem: #class
		change: #Added
		using: #noteClassChanged:;
		
		notify: self
		ofSystemChangesOfItem: #method
		using: #noteMethodChanged:.! !

!MDNotificationAdaptor methodsFor: 'registration' stamp: 'cwp 3/9/2008 13:25'!
registerAll
	SystemChangeNotifier uniqueInstance 
		notify: self ofAllSystemChangesUsing: #transcribe:! !

!MDNotificationAdaptor methodsFor: 'listeners' stamp: 'cwp 3/9/2008 15:22'!
removeListener: anObject
	listeners remove: anObject! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 13:26'!
transcribe: anEvent
	Transcript cr; show: anEvent asString! !

!MDNotificationAdaptor methodsFor: 'registration' stamp: 'cwp 3/9/2008 13:06'!
unregister
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 14:37'!
xor: left with: right
	| result |
	result _ Set new.
	left do: [:ea | (right includes: ea) ifFalse: [result add: ea]].
	right do: [:ea | (left includes: ea) ifFalse: [result add: ea]].
	^ result! !

Object subclass: #MDPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

MDPlatform class
	instanceVariableNames: 'current'!

MDPlatform class
	instanceVariableNames: 'current'!

!MDPlatform class methodsFor: 'as yet unclassified' stamp: 'cwp 5/10/2008 18:51'!
current
	^ current ifNil: [current := self new]! !

!MDPlatform class methodsFor: 'as yet unclassified' stamp: 'cwp 5/10/2008 18:51'!
current: aPlatform
	current := aPlatform! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 11/17/2007 01:25'!
initials
	^ Utilities authorInitials ! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 3/9/2008 16:08'!
notifier
	^ MDNotificationAdaptor default! !

!MDPlatform methodsFor: 'user interface' stamp: 'cwp 12/28/2007 21:06'!
prompt: prompt default: default
	^ OBTextRequest
		prompt: prompt
		template: default! !

!MDPlatform methodsFor: 'constructing' stamp: 'cwp 4/7/2008 23:23'!
serializationMap
	^ MDSerializationMap new! !

!MDPlatform methodsFor: 'cursor' stamp: 'cwp 5/3/2008 01:19'!
showCursor: aSymbol
	| cursor |
	cursor := aSymbol ifNotNil: [Cursor perform: aSymbol].
	ActiveHand showTemporaryCursor: cursor.
	World doOneCycleNow! !

!MDPlatform methodsFor: 'constructing' stamp: 'cwp 12/22/2006 22:25'!
systemEditor
	^ Smalltalk! !

!MDPlatform methodsFor: 'time' stamp: 'cwp 5/10/2008 18:40'!
timestampSeconds
	^ Time primSecondsClock - 2498169600! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 12/28/2007 21:25'!
updateMemoProperties: properties
	properties 
		initials: Utilities authorInitials;
		author: MDAuthorInfo value! !

!MDPlatform methodsFor: 'testing' stamp: 'cwp 3/2/2008 12:19'!
variablePointersObject
	^ (ActionSequence new: 2)
		at: 1 put: #a;
		at: 2 put: #b;
		yourself! !

!MDPlatform methodsFor: 'cursor' stamp: 'cwp 12/22/2007 22:27'!
withCursor: aSymbol do: aBlock
	self showCursor: aSymbol.
	^ aBlock ensure: [self showCursor: nil]! !

Object subclass: #MDSerializationMap
	instanceVariableNames: 'classMap typeMap defaultSerializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 10:24'!
addHashedSerializersTo: map 
	| serializer |
	serializer := MDHashedObjectSerializer type: 23.
	MDHashedObject allSubclassesDo: 
		[ :class | map at: class put: serializer ]! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 13:42'!
addKnownClassesTo: map 
	self knownClasses withIndexDo:
		[:class :id |
		map 
			at: class class
			put: (MDKnownClassSerializer id: id)]! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 13:45'!
createClassMap
	| map |
	map := IdentityDictionary new.
	map 
		at: UndefinedObject put: (MDSingletonSerializer type: 6);
		at: True put: (MDSingletonSerializer type: 7);
		at: False put: (MDSingletonSerializer type: 8);
		at: SmallInteger put: MDSmallIntegerSerializer new;
		at: LargePositiveInteger put: (MDLargeIntegerSerializer type: 12);
		at: LargeNegativeInteger put: (MDLargeIntegerSerializer type: 13);
		at: ByteSymbol put: (MDUtf8Serializer type: 14);
		at: WideSymbol put: (MDUtf8Serializer type: 14);
		at: ByteString put: (MDUtf8Serializer type: 15);
		at: WideString put: (MDUtf16Serializer type: 16);
		at: Array put: (MDArraySerializer type: 17);
		at: Set put: (MDSetSerializer type: 18);
		at: Dictionary put: (MDDictionarySerializer type: 19);
		at: MDPropertyDictionary put: (MDDictionarySerializer type: 20);
		at: MDTimestamp put: (MDBytesSerializer type: 21);
		at: MDHashstamp put: (MDBytesSerializer type: 22).
	self addHashedSerializersTo: map.
	self addKnownClassesTo: map.
	^ map! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 13:39'!
createTypeMap
	^ { 
		(MDObjectMaterializer new).
		(MDClassMaterializer new).
		(MDClassMaterializer new).
		(MDClassMaterializer new).
		MDKnownClassMaterializer class: self knownClasses.
		(MDSingletonMaterializer object: nil).
		(MDSingletonMaterializer object: true).
		(MDSingletonMaterializer object: false).
		(MDSmallIntegerMaterializer new).
		(MDSmallIntegerMaterializer new).
		(MDSmallIntegerMaterializer new).
		(MDLargeIntegerMaterializer class: LargePositiveInteger).
		(MDLargeIntegerMaterializer class: LargeNegativeInteger).
		(MDUtf8Materializer forSymbol).
		(MDUtf8Materializer forString).
		(MDUtf16Materializer new).
		(MDArrayMaterializer class: Array).
		(MDSetMaterializer class: Set).
		(MDDictionaryMaterializer class: Dictionary).
		(MDDictionaryMaterializer class: MDPropertyDictionary).
		(MDBytesMaterializer class: MDTimestamp).
		(MDBytesMaterializer class: MDHashstamp).
		(MDHashedObjectMaterializer new)
	 }! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/12/2008 02:18'!
initialize
	classMap := self createClassMap.
	typeMap := self createTypeMap.
	defaultSerializer := MDObjectSerializer type: 1.! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/30/2008 07:01'!
knownClasses
	^ { 
		MDSliceElement.
		MDDefinitionVariant.
		MDRemovalVariant.
		MDNullVersion.
		MDElementVersion.
		MDSnapshot.
		MDMemo.
		MDFakeElement.
		MDClassElement.
		MDClassCommentElement.
		MDInstVarElement.
		MDClassVarElement.
		MDClassInstVarElement.
		MDPoolImportElement.
		MDMethodElement
	 }! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/8/2008 20:03'!
materializerForType: anInteger 
	^ typeMap at: anInteger! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 12:00'!
serializerForObject: anObject
	^ classMap
		at: anObject class
		ifAbsent: 
			[anObject isBehavior
				ifTrue: [MDClassSerializer new]
				ifFalse: [defaultSerializer]]! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/7/2008 23:49'!
stringClass
	^ (Smalltalk hasClassNamed: #ByteString)
		ifTrue: [Smalltalk at: #ByteString]
		ifFalse: [Smalltalk at: #String]! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/7/2008 23:48'!
symbolClass
	^ (Smalltalk hasClassNamed: #ByteSymbol)
		ifTrue: [Smalltalk at: #ByteSymbol]
		ifFalse: [Smalltalk at: #Symbol]! !
MDAuthorInfo initialize!
